'use strict';

const constraintViolationError = require('../src/constraint-violation-error');
const should = require('should');

describe('The constraint violation error object', function () {
    describe('#createError', function () {
        it('should contain the original error', function testConstraintViolationErrorContainsOriginalError() {
            const originalError = new Error('Orignal error that triggers the datasouce to attempt to violate database constraint');
            const sut = constraintViolationError.createError(originalError);
            sut.cause().should.equal(originalError);
        });
    });
    describe('GIVEN #isConstraintViolationError is called with a vanilla error', function () {
        it('THEN it should return false', function () {
            constraintViolationError.isConstraintViolationError(new Error()).should.eql(false);
        });
    });
    describe('GIVEN #isConstraintViolationError is called with an error created by #createError', function () {
        it('THEN it should return true', function () {
            constraintViolationError.isConstraintViolationError(constraintViolationError.createError(new Error())).should.eql(true);
        });
    });
});